#include "computersetting.h"

ComputerSetting::ComputerSetting()
{
}

ComputerSetting ComputerSetting::getComputerSettings(QString computersFile)
{
	ComputerSetting ret;
	if ( ! computersFile.isEmpty() )
	{
		if ( QFileInfo( computersFile ).isRelative() )
		{
			computersFile = QString(CONF_DIR) + QDir::separator() + computersFile;
		}

		QSettings computerSettings( computersFile, QSettings::IniFormat );

		QStringList keys = Settings::getKeys( "Default Login" );
		for ( int i = 0; i < keys.count(); i++ )
		{
			ret.setUser(keys[i], computerSettings.value( "Default Login/" + keys[i] ).toString());
		}

		keys = Settings::getKeys( "Default Session" );
		for ( int i = 0; i < keys.count(); i++ )
		{
			ret.setSession(keys[i], computerSettings.value( "Default Session/" + keys[i] ).toString());
		}
	}
	return ret;
}

QStringList ComputerSetting::userKeys()
{
	return _computerUser.keys();
}

QStringList ComputerSetting::sessionKeys()
{
	return _computerSession.keys();
}

QString ComputerSetting::user( QString computer )
{
	return _computerUser[computer];
}

QString ComputerSetting::session( QString computer )
{
	return _computerSession[computer];
}

void ComputerSetting::setUser( QString computer, QString user )
{
	_computerUser[computer] = user;
}

void ComputerSetting::setSession( QString computer, QString session )
{
	_computerSession[computer] = session;
}
