#ifndef COMPUTERSETTING_H
#define COMPUTERSETTING_H

#include <QString>
#include <QHash>
#include <QFileInfo>
#include <QDir>

#include "constants.h"
#include "settings.h"

class ComputerSetting
{
	public:
		ComputerSetting();

		static ComputerSetting getComputerSettings(QString computersFile);

		QStringList userKeys();
		QStringList sessionKeys();

		QString user( QString computer );
		QString session( QString computer );

		void setUser( QString computer, QString user );
		void setSession( QString computer, QString session );
	private:
		QHash<QString,QString> _computerUser;
		QHash<QString,QString> _computerSession;
};

#endif
