#include "logger.h"

static QMutex mutex;

void Logger::logInfo(QString text)
{
	log( "Info: " + text );
	qDebug("Info: %s", text.toUtf8().data());
}

void Logger::logWarning(QString text)
{
	log( "Warning: " + text );
	qDebug("libnss_librework. Warning: %s", text.toUtf8().data());
}

void Logger::logError(QString text)
{
	log( "Error: " + text );
	qDebug("libnss_librework. Error: %s", text.toUtf8().data());
}

void Logger::logDebug(QString text)
{
	if ( DEBUG == 1 )
	{
		log( "Debug: " + text );
	}
	qDebug("libnss_librework. Debug: %s", text.toUtf8().data());
}

void Logger::log(QString text)
{
	mutex.lock();
	QFile logFile(LOG_FILE);
	if ( logFile.open(QIODevice::Append) )
	{
		QByteArray logLine;
		logLine += text;
		logFile.write( QDateTime::currentDateTime().toString(Qt::RFC2822Date).toUtf8() + " - " + logLine + "\n" );
		logFile.close();
	}
	mutex.unlock();
}
