#include "login1.h"

Login1::Login1() : QObject()
{
}

QDBusInterface * Login1::interface( QString path, QString interface )
{
	QDBusInterface * ret = new QDBusInterface( "org.freedesktop.login1",
		path,
		interface,
		QDBusConnection::systemBus());

	if ( ! ret->isValid())
	{
		qDebug() << "dBus iface for " << interface << " is not Valid: " << ret->lastError().message();
	}

	return ret;
}

QDBusInterface * Login1::interface()
{
	return interface( _path, _interface );
}

QVariant Login1::getProperty( QString property )
{
	QVariant ret;

	QDBusInterface * dbus = interface();

	if ( ! dbus->isValid() )
	{
		qDebug("Cannot get property %s", property.toUtf8().data());
		delete dbus;
		return ret;
	}

	ret = dbus->property( property.toUtf8().data() );

	delete dbus;

	return ret;
}
