#ifndef LOGIN1MANAGER_H
#define LOGIN1MANAGER_H

#include <QtCore>
#include <QtDBus>

#include <sys/types.h>
#include <unistd.h>

#include "login1.h"
#include "dbussession.h"
#include "dbusseat.h"
#include "logger.h"

class Login1Manager : public Login1
{
	Q_OBJECT

	public:
		Login1Manager();

		QList<Session> listSessions();
		QList<Seat> listSeats();
		QString currentSessionPath();
		bool activateSession(QString sessionId);
		bool releaseSession(QString sessionId);
		bool activateSessionOnSeat(QString sessionId, QString seatId);
		bool suspend(bool interactive);

	public slots:
		void sessionNewSlot(QString sessionId, QDBusObjectPath objectPath);
		void sessionRemovedSlot(QString sessionId, QDBusObjectPath objectPath);
		void seatNewSlot(QString seatId, QDBusObjectPath objectPath);
		void seatRemovedSlot(QString seatId, QDBusObjectPath objectPath);
		void userNewSlot(QString uid, QDBusObjectPath objectPath);
		void userRemovedSlot(QString uid, QDBusObjectPath objectPath);

	signals:
		void sessionNew(QString sessionId, QDBusObjectPath objectPath);
		void sessionRemoved(QString sessionId, QDBusObjectPath objectPath);
		void seatNew(QString seatId, QDBusObjectPath objectPath);
		void seatRemoved(QString seatId, QDBusObjectPath objectPath);
		void userNew(QString uid, QDBusObjectPath objectPath);
		void userRemoved(QString uid, QDBusObjectPath objectPath);
};

#endif
