#include "login1seat.h"

Login1Seat::Login1Seat( QString seatId )
{
	_seatId = seatId;
	_path = "/org/freedesktop/login1/seat/" + _seatId;
	_interface = "org.freedesktop.login1.Seat";
}

QString Login1Seat::seatId()
{
	return _seatId;
}

bool Login1Seat::activateSession(QString sessionId)
{
	bool ret = false;

	QDBusInterface * dbus = interface();

	if ( ! dbus->isValid() )
	{
		delete dbus;
		return ret;
	}

	QDBusReply<bool> reply = dbus->call("ActivateSession", sessionId);

	if ( ! reply.isValid())
	{
		qDebug() << "dBus reply for ActivateSession is not valid: " << reply.error().message();
		delete dbus;
		return ret;
	}

	ret = reply.value();

	delete dbus;

	return ret;
}
