#include "login1session.h"

Login1Session::Login1Session( QString sessionPath )
{
	_path = sessionPath;
	_interface = "org.freedesktop.login1.Session";
}

bool Login1Session::takeControl(bool force)
{
	bool ret = false;

        QDBusInterface * dbus = interface();

        if ( ! dbus->isValid() )
        {
                delete dbus;
                return ret;
        }

        QDBusReply<void> reply = dbus->call("TakeControl", force);

        if ( ! reply.isValid())
        {
                qDebug() << "dBus reply for TakeControl is not valid: " << reply.error().message();
        } else {
		ret = true;
	}

        delete dbus;

        return ret;
}

QString Login1Session::sessionPath()
{
	return _path;
}

QString Login1Session::getType()
{
	return getProperty( "Type" ).toString();
}

QString Login1Session::getClass()
{
	return getProperty( "Class" ).toString();
}

int Login1Session::getVTNumber()
{
	QVariant ret = getProperty( "GetVTNr" );
	qDebug(ret.toString().toUtf8().data());
	if ( ! ret.isNull() )
	{
		return ret.toInt();
	} else {
		return -1;
	}
}
