#ifndef LWCLIENT_H
#define LWCLIENT_H

#include <QObject>
#include <QString>
#include <QByteArray>
#include <QMutex>
#include <QThread>

#include <liblwnet/lwsocket.h>

#include "settings.h"
#include "constants.h"

class LWClient
{
	public:
		static bool connect(QString address, int port = -1);
		static void close();
		static bool authenticate(QString username, QString password);
		static bool isConnected() { return _isConnected; };
		static QString sendMessage(QString message);
		static QString sendMessage(QString command, QStringList parameters);

	private:
		static SOCKET tcpSocket;
		static bool _isConnected;
		static QMutex mutex;
};

#endif
