#ifndef PAM_H
#define PAM_H

#include <QString>

#include "logger.h"

#include <security/pam_appl.h>
#include <security/pam_misc.h>

class Pam : public QObject
{
	public:
		static int functionConversation(int numMsg, const struct pam_message **msg, struct pam_response ** resp, void *appdata_ptr);
		static bool authenticateSystemUser( QString username, QString password );
		static bool startPam( bool greeter, QString service, QString username );
		static bool stopPam( bool greeter, int retval );
		static bool openSession( QString xdgSessionClass, QString seat );
		static bool closeSession( bool greeter );
};

#endif //PAM_H
