#include "power.h"

static Power * _instance = 0;

Power::Power(QObject *parent) : QObject(parent)
{

}

Power * Power::instance()
{
	if ( _instance == 0 )
	{
		_instance = new Power();
	}
	return _instance;
}

void Power::suspend()
{
	/*
	// Open ConsoleKit session and create XDG_SESSION_COOKIE variable
	QByteArray cookie;
	QByteArray ssid;
	QDBusInterface dbusManager( "org.freedesktop.login1", "/org/freedesktop/login1", "org.freedesktop.login1", QDBusConnection::systemBus() );
	if ( dbusManager.isValid() )
	{
		QDBusMessage msg = dbusManager.call( "CreateSession" );
		if ( ! msg.errorName().isEmpty() )
		{
			qDebug("Cannot open session. Error: %s", msg.errorName().toUtf8().data());
		} else {
			QList<QVariant> args = msg.arguments();
			if ( args.count() >= 1 )
			{
				cookie = args[0].toByteArray();
				qputenv("XDG_SESSION_COOKIE", cookie );
				qDebug("Session cookie: %s", cookie.data());
				QDBusMessage msg2 = dbusManager.call( "GetSessionForCookie", "c5086f77960c43eb87c31917a1a0ac92-1518111683.415617-200968043" );
				if ( ! msg2.errorName().isEmpty() )
				{
					qDebug("Cannot get session for cookie %s. Error: %s", args[0].toByteArray().data(), msg2.errorName().toUtf8().data());
				} else {
					QList<QVariant> sargs = msg2.arguments();
					if ( sargs.count() >= 1 )
					{
						QBitArray ba = sargs[0].toBitArray();
						qDebug("BitArray: %d", ba.count());
						ssid = sargs[0].toByteArray();
						long long ssidInt = sargs[0].toLongLong();
						qDebug("Session count: %d, ssid: '%s' '%lld' Message type: %d", sargs.count(), ssid.data(), ssidInt, msg2.type());
					} else {
						qDebug("No response from system bus to get session for cookie.");
					}
				}
			} else {
				qDebug("No response from system bus to open session.");
			}
		}
	} else {
		qDebug("Cannot connect to system bus. Cannot open session.");
	}

	// Activate ConsoleKit session
	if ( ! ssid.isEmpty() )
	{
		QDBusInterface dbusSession( "org.freedesktop.ConsoleKit", "/org/freedesktop/ConsoleKit/Seat", "org.freedesktop.ConsoleKit.Seat", QDBusConnection::systemBus() );
		if ( dbusSession.isValid() )
		{
			QDBusMessage msg = dbusSession.call( "ActivateSession", ssid );
			if ( ! msg.errorName().isEmpty() )
			{
				qDebug("Cannot activate session. Error: %s", msg.errorName().toUtf8().data());
			} else {
				qDebug("Activated session %s", ssid.data());
			}
		} else {
			qDebug("Cannot connect to system bus. Cannot activate session.");
		}
	}*/

	QProcess shutdown;
#if defined(Q_OS_LINUX) || defined(Q_OS_FREEBSD)
	/*QDBusInterface dbus("org.freedesktop.ConsoleKit", "/org/freedesktop/ConsoleKit/Manager", "org.freedesktop.ConsoleKit.Manager", QDBusConnection::systemBus() );
	//QDBusInterface dbus("org.freedesktop.UPower", "/org/freedesktop/UPower", "org.freedesktop.UPower", QDBusConnection::systemBus() );
	//QDBusInterface dbus("org.freedesktop.login1", "/org/freedesktop/login1", "org.freedesktop.login1.Manager", QDBusConnection::systemBus() );
	if ( dbus.isValid() )
	{
		QDBusMessage msg = dbus.call( "Suspend", true );
		if ( ! msg.errorName().isEmpty() )
		{
			qDebug("Cannot suspend!");
			qDebug("Error: %s", msg.errorName().toUtf8().data());
		}
	} else {
		qDebug("Cannot connect to system bus. Cannot Suspend.");
	}*/
	shutdown.startDetached("/usr/bin/systemctl suspend");
#endif
#ifdef Q_OS_WIN
	shutdown.startDetached("rundll32.exe powrprof.dll,SetSuspendState Standby");
#endif
}

void Power::hibernate()
{
	QProcess shutdown;
#if defined(Q_OS_LINUX) || defined(Q_OS_FREEBSD)
	shutdown.startDetached("/usr/bin/systemctl hibernate");
#endif
#ifdef Q_OS_WIN
	shutdown.startDetached("rundll32.exe powrprof.dll,SetSuspendState Hibernate");
#endif
}

void Power::reboot()
{
	QProcess shutdown;
#if defined(Q_OS_LINUX) || defined(Q_OS_FREEBSD)
	shutdown.startDetached("/usr/sbin/shutdown -r now");
#endif
#ifdef Q_OS_WIN
	shutdown.startDetached("shutdown -r -t 0");
#endif
}

void Power::powerOff()
{
	QProcess shutdown;
#if defined(Q_OS_LINUX) || defined(Q_OS_FREEBSD)
	/*QDBusInterface dbus("org.freedesktop.login1", "/org/freedesktop/login1", "org.freedesktop.login1.Manager", QDBusConnection::systemBus() );
	if ( dbus.isValid() )
	{
		QDBusMessage msg = dbus.call( "Suspend" );
		if ( ! msg.errorName().isEmpty() )
		{
			qDebug("Cannot suspend!");
		}
	} else {
		qDebug("Cannot connect to system bus. Cannot Suspend.");
	}*/
	shutdown.startDetached("/usr/sbin/shutdown -P now");
#endif
#ifdef Q_OS_WIN
	shutdown.startDetached("shutdown -s -t 0");
#endif
}
