#ifndef SESSIONSETTING_H
#define SESSIONSETTING_H

#include <QList>
#include <QString>
#include <QIcon>

#include "constants.h"
#include "settings.h"
#include "sharesetting.h"
#include "computersetting.h"
#include "utils.h"

class SessionSetting
{
	public:
		SessionSetting(int id, QString name, QIcon icon, QString desktop, QString authentication, QString clientSession, QList<ShareSetting> shares, ComputerSetting computers, QStringList blackList, QStringList whiteList);

		static QList<SessionSetting> getSessionSettings();

		int id() { return _id; };
		QString name() { return _name; };
		QIcon icon() { return _icon; };
		QString desktop() { return _desktop; };
		QString authentication() { return _authentication; };
		QString clientSession() { return _clientSession; };
		QList<ShareSetting> shares() { return _shares; };
		ComputerSetting computers() { return _computers; };
		QStringList blackList() { return _blackList; };
		QStringList whiteList() { return _whiteList; };

		bool isRemote();
		bool isLibrework();
		bool isLocal();

		void setName( QString name ) { _name = name; };
		void setIcon( QIcon icon ) { _icon = icon; };
		void setDesktop( QString desktop ) { _desktop = desktop; };
		void setAuthentication( QString authentication ) { _authentication = authentication; };
		void setClientSession( QString clientSession ) { _clientSession = clientSession; };
		void setShares( QList<ShareSetting> shares ) { _shares = shares; };
		void setComputers( ComputerSetting computers ) { _computers = computers; };
		void setBlackList( QStringList blackList ) { _blackList = blackList; };
		void setWhiteList( QStringList whiteList ) { _whiteList = whiteList; };
	private:
		int _id;
		QString _name;
		QIcon _icon;
		QString _desktop;
		QString _authentication;
		QString _clientSession;
		QList<ShareSetting> _shares;
		ComputerSetting _computers;
		QStringList _blackList;
		QStringList _whiteList;
};

#endif
