#ifndef SETTINGS_H
#define SETTINGS_H

#include <QString>
#include <QStringList>
#include <QVariant>
#include <QFile>
#include <QSettings>

#include "constants.h"

class Settings
{
	public:
		static QString getKeyboardValue( QString key, QString defaultValue = QString::null );
		static QString getLocaleValue( QString key, QString defaultValue = QString::null );
		static QVariant getValue( QString key, QVariant defaultValue = QVariant() );
		static QStringList getKeys( QString group = QString() );

		static void setValue( QString key, QVariant value );

	private:
		static QString getDefaultFileValue( QString file, QString key, QString defaultValue );
};

#endif // SETTINGS_H
