#ifndef SHARES_H
#define SHARES_H

#include <QFile>
#include <QDir>
#include <QProcess>
#include <QStandardPaths>
#include <QObject>

#include "settings.h"
#include "sessionmanager.h"
#include "sysuser.h"
#include "lwclient.h"
#include "logger.h"
#include "sessionsetting.h"
#include "sharesetting.h"

class Shares : public QObject
{
	public:
		static QString credentialsFile(QString username, QString password, QString domain, QString separator = "=");
		static bool mountHome(QString username, QString password, QString domain, QString homeDir, SessionSetting sessionSetting);
		static bool mountSshHome(QString username, QString password, QString domain, QString homeDir, SessionSetting sessionSetting);
		static bool mountSmbHome(QString username, QString password, QString domain, QString homeDir, SessionSetting sessionSetting);
		static bool mountShare(QString username, QString password, QString domain, QString homeDir, ShareSetting shareSetting);
		static bool mountSshShare(QString username, QString password, QString domain, QString homeDir, ShareSetting shareSetting);
		static bool mountSmbShare(QString username, QString password, QString domain, QString homeDir, ShareSetting shareSetting);
		static bool smbMount(QString username, QString password, QString domain, QString smbPath, QString targetPath);
		static bool sshMount(QString username, QString password, QString serverAddress, QString sourcePath, QString targetPath);
		static bool smbAuth(QString username, QString password, QString domain, QString serverName);
		static void smbUmountAll();
		static void sshUmountAll();
};

#endif //SHARES_H
