#ifndef SHARESETTING_H
#define SHARESETTING_H

#include <QList>
#include <QString>
#include <QSettings>
#include <QFileInfo>
#include <QDir>

#include "settings.h"

class ShareSetting
{
	public:
		ShareSetting(QString targetDir, bool isHome, bool isPrinter, QString protocol, QString domain, QString serverAddress, QString sourcePath, QString targetPath);

		static QList<ShareSetting> getShareSettings(QString sharesFile);

		QString targetDir() { return _targetDir; };
		bool isHome() { return _isHome; };
		bool isPrinter() { return _isPrinter; };
		QString protocol() { return _protocol; };
		QString domain() { return _domain; };
		QString serverAddress() { return _serverAddress; };
		QString sourcePath() { return _sourcePath; };
		QString targetPath() { return _targetPath; };

		void setTargetDir( QString targetDir ) { _targetDir = targetDir; };
		void setIsHome( bool isHome ) { _isHome = isHome; };
		void setIsPrinter( bool isPrinter ) { _isPrinter = isPrinter; };
		void setProtocol( QString protocol ) { _protocol = protocol; };
		void setDomain( QString domain ) { _domain = domain; };
		void setServerAddress( QString serverAddress ) { _serverAddress = serverAddress; };
		void setSourcePath( QString sourcePath ) { _sourcePath = sourcePath; };
		void setTargetPath( QString sourcePath ) { _sourcePath = sourcePath; };

	private:
		QString _targetDir;
		bool _isHome;
		bool _isPrinter;
		QString _protocol;
		QString _domain;
		QString _serverAddress;
		QString _sourcePath;
		QString _targetPath;
};

#endif
