#ifndef SYSUSER_H
#define SYSUSER_H

#include <QString>
#include <QStringList>
#include <QSettings>
#include <QProcess>
#include <QFile>
#include <QDir>
#include <QTextStream>
#include <QCryptographicHash>

#include "constants.h"
#include "logger.h"
#include "settings.h"

#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <grp.h>
#include <pwd.h>

class SysUser : public QObject
{
	public:

		static void getUserAndGroupIds( QString username, int * uid, int * gid );
		static QString getUserHome( QString username );
		static QString createHome( QString homes, QString username );
		static void createHomeLinks(QString sourceDir, QString homeDir, QString username);
		static void createDesktopLinks(QString homeDir, QString username, bool setPermissions = false);
		static bool createSystemUser(int uid, QString homes, QString username, QString password );
		static void writeToken( QString username, QString homeDir, QString token );
};

#endif //SYSUSER_H
