#include "utils.h"

QString Utils::absoluteConfigFilePath(QString fileName)
{
	if ( QFileInfo( fileName ).isRelative() )
	{
		return QString( CONF_DIR ) + QDir::separator() + fileName;
	} else {
		return fileName;
	}
}

QStringList Utils::fileToStringList(QString fileName)
{
	QStringList ret;
	QFile file( fileName );
	file.open( QIODevice::ReadOnly );
	QTextStream textStream(&file);
	while (! textStream.atEnd())
	{
		QString line = textStream.readLine();
		if ( ! line.isEmpty() && ! line.startsWith('#') )
		{
			ret.append(line.simplified());
		}
	}
	file.close();
	return ret;
}

QString Utils::resolveVariables( QString string, QStringList variables, QStringList values )
{
	QString ret = string;
	if ( variables.count() == values.count() )
	{
		for ( int i = 0; i < variables.count(); i++ )
		{
			ret = ret.replace( variables[i], values[i] );
		}
	}
	return ret;
}
