#!/bin/bash

EXISTS=$(lsmod | grep snd_hda_intel)

if [ -n "$EXISTS" ]
then
	touch /tmp/testrealtek.log
	touch /tmp/test.wav
	aplay /tmp/test.wav 2>&1 >> /tmp/testrealtek.log
	RESULT=$?
	if [ "$RESULT" == "0" ]
	then
		exit 0
	fi

	alsactl kill quit >> /tmp/testrealtek.log 2>&1
	sleep 1
	alsactl nrestore >> /tmp/testrealtek.log 2>&1
	sleep 1

	for i in 0 1
	do
		echo "Testing card $i" >> /tmp/testrealtek.log
		alsactl kill quit >> /tmp/testrealtek.log 2>&1
		sleep 1
		modprobe -r snd_hda_intel >> /tmp/testrealtek.log 2>&1
		sleep 3
		modprobe snd_hda_intel index=$i >> /tmp/testrealtek.log 2>&1
		sleep 3
		aplay /tmp/test.wav >> /tmp/testrealtek.log 2>&1
		RESULT=$?
		if [ "$RESULT" == "0" ]
		then
			echo "Card $i succesful" >> /tmp/testrealtek.log
			break
		else
			echo "Card $i failed" >> /tmp/testrealtek.log
		fi
	done
fi
